﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NormalMatModel
{
    internal class MinMethod
    {
        static int[,] printTable;
        static List<int> valueCell = new List<int>();
        static List<int> valueRoot = new List<int>();
        private static int[] SearchMinValue(int[,] tableAll)
        {
            int minVal = tableAll[1, 1];
            int[] arrayIndex = new int[2];
            for (int i = 1; i < tableAll.GetLength(0); i++)
            {
                for (int j = 1; j < tableAll.GetLength(1); j++)
                {
                    if (tableAll[i, j] < minVal)
                    {
                        minVal = tableAll[i, j];
                        arrayIndex[0] = i;
                        arrayIndex[1] = j;
                    }
                }
            }
            return arrayIndex;
        }
        private static bool CheckMinMethod(int[,] tableAll)
        {
            for (int i = 1; i < tableAll.GetLength(0); i++)
            {
                for (int j = 1; j < tableAll.GetLength(1); j++)
                {
                    if (tableAll[i, j] != int.MaxValue)
                    {
                        return true;
                    }
                }
            }
            return false;
        }
        public static void MainWork(int[,] tableAll)
        {
            printTable = new int[tableAll.GetLength(0), tableAll.GetLength(1)];
            while (CheckMinMethod(tableAll))
            {
                int[] arrayMinIndex = SearchMinValue(tableAll);
                int minValue = Math.Min(tableAll[arrayMinIndex[0], 0], tableAll[0, arrayMinIndex[1]]);
                tableAll[arrayMinIndex[0], 0] -= minValue;
                tableAll[0, arrayMinIndex[1]] -= minValue;
                printTable[arrayMinIndex[0], arrayMinIndex[1]] = minValue;
                valueCell.Add(minValue);
                valueRoot.Add(tableAll[arrayMinIndex[0], arrayMinIndex[1]]);
                tableAll[arrayMinIndex[0], arrayMinIndex[1]] = minValue;

                switch (tableAll[arrayMinIndex[0], 0] == 0)
                {
                    case true:
                        for (int k = 1; k < tableAll.GetLength(1); k++)
                        {
                            tableAll[arrayMinIndex[0], k] = int.MaxValue;
                        }
                        break;
                    case false:
                        for (int k = 1; k < tableAll.GetLength(0); k++)
                        {
                            tableAll[k, arrayMinIndex[1]] = int.MaxValue;
                        }
                        break;
                }

            }
            var countLx = () =>
            {
                int sum = 0;
                for (int i = 0; i < valueRoot.Count; i++)
                {
                    sum += valueRoot[i] * valueCell[i];
                }
                return sum;
            };
            Console.WriteLine(countLx());

            for (int i = 0; i < printTable.GetLength(0); i++)
            {
                for (int j = 0; j < printTable.GetLength(1); j++)
                {
                    Console.Write("{0,8:0}", printTable[i, j]);
                }
                Console.WriteLine();
            }
        }
    }
}
